# coding: utf-8

"""
    Klaviyo API

    The Klaviyo REST API. Please visit https://developers.klaviyo.com for more details.  # noqa: E501

    The version of the OpenAPI document: 2023-08-15
    Contact: developers@klaviyo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr
from openapi_client.models.audiences_sub_object import AudiencesSubObject
from openapi_client.models.send_strategy_sub_object import SendStrategySubObject

class CampaignPartialUpdateQueryResourceObjectAttributes(BaseModel):
    """
    CampaignPartialUpdateQueryResourceObjectAttributes
    """
    name: Optional[StrictStr] = Field(None, description="The campaign name")
    audiences: Optional[AudiencesSubObject] = None
    send_options: Optional[Dict[str, Any]] = Field(None, description="Options to use when sending a campaign")
    tracking_options: Optional[Dict[str, Any]] = Field(None, description="The tracking options associated with the campaign")
    send_strategy: Optional[SendStrategySubObject] = None
    __properties = ["name", "audiences", "send_options", "tracking_options", "send_strategy"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CampaignPartialUpdateQueryResourceObjectAttributes:
        """Create an instance of CampaignPartialUpdateQueryResourceObjectAttributes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of audiences
        if self.audiences:
            _dict['audiences'] = self.audiences.to_dict()
        # override the default output from pydantic by calling `to_dict()` of send_strategy
        if self.send_strategy:
            _dict['send_strategy'] = self.send_strategy.to_dict()
        # set to None if name (nullable) is None
        # and __fields_set__ contains the field
        if self.name is None and "name" in self.__fields_set__:
            _dict['name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CampaignPartialUpdateQueryResourceObjectAttributes:
        """Create an instance of CampaignPartialUpdateQueryResourceObjectAttributes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CampaignPartialUpdateQueryResourceObjectAttributes.parse_obj(obj)

        _obj = CampaignPartialUpdateQueryResourceObjectAttributes.parse_obj({
            "name": obj.get("name"),
            "audiences": AudiencesSubObject.from_dict(obj.get("audiences")) if obj.get("audiences") is not None else None,
            "send_options": obj.get("send_options"),
            "tracking_options": obj.get("tracking_options"),
            "send_strategy": SendStrategySubObject.from_dict(obj.get("send_strategy")) if obj.get("send_strategy") is not None else None
        })
        return _obj

